var $CLJS = require("./cljs_env");
require("./cljs.core.js");
require("./cljs.reader.js");
require("./shadow.js.shim.module$readline.js");
require("./shadow.js.shim.module$net.js");
require("./shadow.js.shim.module$fs.js");
require("./shadow.cljs.npm.util.js");
require("./clojure.string.js");
var clojure=$CLJS.clojure;
var cljs=$CLJS.cljs;
var shadow=$CLJS.shadow;
var goog=$CLJS.goog;

goog.dependencies_.written["shadow.cljs.npm.client.js"] = true;

goog.provide('shadow.cljs.npm.client');
goog.require('cljs.core');
goog.require('cljs.reader');
goog.require('shadow.js.shim.module$readline');
goog.require('shadow.js.shim.module$net');
goog.require('shadow.js.shim.module$fs');
goog.require('shadow.cljs.npm.util');
goog.require('clojure.string');
/**
 * readline client that tries to maintain a prompt. not quite smart yet.
 */
shadow.cljs.npm.client.repl_client = (function shadow$cljs$npm$client$repl_client(socket,args){
var last_prompt_ref = cljs.core.volatile_BANG_(null);
var rl = (function (){var G__41198 = ({"input": process.stdin, "output": process.stdout, "completer": ((function (last_prompt_ref){
return (function (prefix,callback){
var last_prompt = cljs.core.deref(last_prompt_ref);
if(cljs.core.not(last_prompt)){
var G__41209 = null;
var G__41210 = cljs.core.clj__GT_js(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.PersistentVector.EMPTY,prefix], null));
return (callback.cljs$core$IFn$_invoke$arity$2 ? callback.cljs$core$IFn$_invoke$arity$2(G__41209,G__41210) : callback.call(null,G__41209,G__41210));
} else {
var G__41229 = null;
var G__41231 = cljs.core.clj__GT_js(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.PersistentVector.EMPTY,prefix], null));
return (callback.cljs$core$IFn$_invoke$arity$2 ? callback.cljs$core$IFn$_invoke$arity$2(G__41229,G__41231) : callback.call(null,G__41229,G__41231));
}
});})(last_prompt_ref))
});
return shadow.js.shim.module$readline.createInterface(G__41198);
})();
var write = ((function (last_prompt_ref,rl){
return (function (text){
cljs.core.vreset_BANG_(last_prompt_ref,null);

return socket.write(text);
});})(last_prompt_ref,rl))
;
var repl_mode_QMARK_ = false;
var exit_token = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.random_uuid())].join('');
var error_token = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.random_uuid())].join('');
var stop_BANG_ = ((function (last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token){
return (function (){
rl.close();

socket.end();

return cljs.core.println();
});})(last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token))
;
cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["shadow-cljs - connected to server"], 0));

write(["(shadow.cljs.devtools.cli/from-remote ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([exit_token], 0)))," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([error_token], 0)))," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,args)], 0))),")\n"].join(''));

rl.on("line",((function (last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token,stop_BANG_){
return (function (line){
return write([cljs.core.str.cljs$core$IFn$_invoke$arity$1(line),"\n"].join(''));
});})(last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token,stop_BANG_))
);

rl.on("close",((function (last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token,stop_BANG_){
return (function (){
return stop_BANG_();
});})(last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token,stop_BANG_))
);

socket.on("data",((function (last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token,stop_BANG_){
return (function (data){
var txt = data.toString();
var vec__41245 = ((clojure.string.includes_QMARK_(txt,exit_token))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"close","close",1835149582),clojure.string.replace(txt,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(exit_token),"\n"].join(''),"")], null):((clojure.string.includes_QMARK_(txt,error_token))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"exit","exit",351849638),clojure.string.replace(txt,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(error_token),"\n"].join(''),"")], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"continue","continue",-207346553),txt], null)
));
var action = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41245,(0),null);
var txt__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41245,(1),null);
process.stdout.write(txt__$1);

var G__41252 = action;
var G__41252__$1 = (((G__41252 instanceof cljs.core.Keyword))?G__41252.fqn:null);
switch (G__41252__$1) {
case "close":
return stop_BANG_();

break;
case "exit":
return process.exit((1));

break;
case "continue":
var prompts = cljs.core.re_seq(/\[(\d+):(\d+)\]\~([^=> \n]+)=> /,txt__$1);
var seq__41257_41284 = cljs.core.seq(prompts);
var chunk__41258_41285 = null;
var count__41259_41286 = (0);
var i__41260_41287 = (0);
while(true){
if((i__41260_41287 < count__41259_41286)){
var vec__41261_41289 = chunk__41258_41285.cljs$core$IIndexed$_nth$arity$2(null,i__41260_41287);
var prompt_41290 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41261_41289,(0),null);
var root_id_41291 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41261_41289,(1),null);
var level_id_41292 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41261_41289,(2),null);
var ns_41293 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41261_41289,(3),null);
var m_41294 = vec__41261_41289;
cljs.core.vreset_BANG_(last_prompt_ref,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"text","text",-1790561697),prompt_41290,new cljs.core.Keyword(null,"ns","ns",441598760),cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(ns_41293),new cljs.core.Keyword(null,"level","level",1290497552),parseInt(level_id_41292,(10)),new cljs.core.Keyword(null,"root","root",-448657453),parseInt(root_id_41291,(10))], null));

rl.setPrompt(prompt_41290);

var G__41299 = seq__41257_41284;
var G__41300 = chunk__41258_41285;
var G__41301 = count__41259_41286;
var G__41302 = (i__41260_41287 + (1));
seq__41257_41284 = G__41299;
chunk__41258_41285 = G__41300;
count__41259_41286 = G__41301;
i__41260_41287 = G__41302;
continue;
} else {
var temp__5457__auto___41303 = cljs.core.seq(seq__41257_41284);
if(temp__5457__auto___41303){
var seq__41257_41306__$1 = temp__5457__auto___41303;
if(cljs.core.chunked_seq_QMARK_(seq__41257_41306__$1)){
var c__33947__auto___41307 = cljs.core.chunk_first(seq__41257_41306__$1);
var G__41308 = cljs.core.chunk_rest(seq__41257_41306__$1);
var G__41309 = c__33947__auto___41307;
var G__41310 = cljs.core.count(c__33947__auto___41307);
var G__41311 = (0);
seq__41257_41284 = G__41308;
chunk__41258_41285 = G__41309;
count__41259_41286 = G__41310;
i__41260_41287 = G__41311;
continue;
} else {
var vec__41270_41312 = cljs.core.first(seq__41257_41306__$1);
var prompt_41313 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41270_41312,(0),null);
var root_id_41314 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41270_41312,(1),null);
var level_id_41315 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41270_41312,(2),null);
var ns_41316 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41270_41312,(3),null);
var m_41317 = vec__41270_41312;
cljs.core.vreset_BANG_(last_prompt_ref,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"text","text",-1790561697),prompt_41313,new cljs.core.Keyword(null,"ns","ns",441598760),cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(ns_41316),new cljs.core.Keyword(null,"level","level",1290497552),parseInt(level_id_41315,(10)),new cljs.core.Keyword(null,"root","root",-448657453),parseInt(root_id_41314,(10))], null));

rl.setPrompt(prompt_41313);

var G__41319 = cljs.core.next(seq__41257_41306__$1);
var G__41320 = null;
var G__41321 = (0);
var G__41322 = (0);
seq__41257_41284 = G__41319;
chunk__41258_41285 = G__41320;
count__41259_41286 = G__41321;
i__41260_41287 = G__41322;
continue;
}
} else {
}
}
break;
}

if(cljs.core.truth_(cljs.core.deref(last_prompt_ref))){
return rl.prompt(true);
} else {
return null;
}

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__41252__$1)].join('')));

}
});})(last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token,stop_BANG_))
);

return socket.on("end",((function (last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token,stop_BANG_){
return (function (){
return rl.close();
});})(last_prompt_ref,rl,write,repl_mode_QMARK_,exit_token,error_token,stop_BANG_))
);
});
/**
 * client that just pipes everything through the socket without any processing
 */
shadow.cljs.npm.client.socket_pipe = (function shadow$cljs$npm$client$socket_pipe(socket,args){
var write = (function (text){
return socket.write(text);
});
var exit_token = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.random_uuid())].join('');
var error_token = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.random_uuid())].join('');
var stop_BANG_ = ((function (write,exit_token,error_token){
return (function (){
return socket.end();
});})(write,exit_token,error_token))
;
var stdin_read = ((function (write,exit_token,error_token,stop_BANG_){
return (function (buffer){
return write(buffer.toString());
});})(write,exit_token,error_token,stop_BANG_))
;
write(["(shadow.cljs.devtools.cli/from-remote ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([exit_token], 0)))," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([error_token], 0)))," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,args)], 0))),")\n"].join(''));

process.stdin.on("data",stdin_read);

process.stdin.on("close",stop_BANG_);

socket.on("data",((function (write,exit_token,error_token,stop_BANG_,stdin_read){
return (function (data){
var txt = data.toString();
var vec__41328 = ((clojure.string.includes_QMARK_(txt,exit_token))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"close","close",1835149582),clojure.string.replace(txt,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(exit_token),"\n"].join(''),"")], null):((clojure.string.includes_QMARK_(txt,error_token))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"exit","exit",351849638),clojure.string.replace(txt,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(error_token),"\n"].join(''),"")], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"continue","continue",-207346553),txt], null)
));
var action = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41328,(0),null);
var txt__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__41328,(1),null);
process.stdout.write(txt__$1);

var G__41331 = action;
var G__41331__$1 = (((G__41331 instanceof cljs.core.Keyword))?G__41331.fqn:null);
switch (G__41331__$1) {
case "close":
return stop_BANG_();

break;
case "exit":
return process.exit((1));

break;
case "continue":
return null;

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__41331__$1)].join('')));

}
});})(write,exit_token,error_token,stop_BANG_,stdin_read))
);

return socket.on("end",((function (write,exit_token,error_token,stop_BANG_,stdin_read){
return (function (){
process.stdin.removeListener("data",stdin_read);

return process.stdin.removeListener("close",stop_BANG_);
});})(write,exit_token,error_token,stop_BANG_,stdin_read))
);
});
shadow.cljs.npm.client.run = (function shadow$cljs$npm$client$run(project_root,config,server_pid_file,opts,args){
var cli_repl = (function (){var G__41360 = shadow.cljs.npm.util.slurp(server_pid_file);
var G__41361 = (10);
return parseInt(G__41360,G__41361);
})();
if(!(cljs.core.pos_int_QMARK_(cli_repl))){
return cljs.core.prn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"no-socket-repl-port","no-socket-repl-port",-1269578905),server_pid_file,cli_repl], null)], 0));
} else {
var connect_listener = ((function (cli_repl){
return (function (err){
var socket = this;
if(cljs.core.truth_((cljs.core.truth_(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(opts,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"options","options",99638489),new cljs.core.Keyword(null,"stdin","stdin",177433088)], null)))?shadow.cljs.npm.client.socket_pipe(socket,args):shadow.cljs.npm.client.repl_client(socket,args)))){
return null;
} else {
return null;
}
});})(cli_repl))
;
var socket = (function (){var G__41382 = ({"port": cli_repl, "host": "localhost", "timeout": (1000)});
var G__41383 = connect_listener;
return shadow.js.shim.module$net.connect(G__41382,G__41383);
})();
return socket.on("error",((function (connect_listener,socket,cli_repl){
return (function (err){
cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["shadow-cljs - socket connect failed, server process dead?"], 0));

shadow.js.shim.module$fs.unlinkSync(server_pid_file);

cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["deleted pid file, please retry command to start new server"], 0));

return process.exit((1));
});})(connect_listener,socket,cli_repl))
);
}
});

module.exports = shadow.cljs.npm.client;

//# sourceMappingURL=shadow.cljs.npm.client.js.map
